import { Application } from '@hotwired/stimulus';
import TurboPower from 'turbo_power';
import Notification from '@stimulus-components/notification';
import Dropdown from '@stimulus-components/dropdown';
import Clipboard from '@stimulus-components/clipboard';
import Sortable from '@stimulus-components/sortable'

const application = Application.start();
application.register('notification', Notification);
application.register('dropdown', Dropdown);
application.register('clipboard', Clipboard);
application.register('sortable', Sortable)

TurboPower.initialize(Turbo.StreamActions);
// Configure Stimulus development experience
application.debug = false;
window.Stimulus = application;

export { application };
