import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['container'];

  addHostname(event) {
    event.preventDefault();
    const newField = document.createElement('div');
    newField.innerHTML = `
    <div class="hostname-entry flex flex-row">
      <input type="text" name="user[hostnames][]" class="form-input w-full">
      <button type="button" data-action="click->hostnames#removeHostname" class="btn border-slate-200 hover:border-slate-300 text-rose-500">
        <i class="fa fa-close"></i>
      </button>
    </div>
    `;
    this.containerTarget.appendChild(newField);
  }

  removeHostname(event) {
    event.preventDefault();
    if (event.target.closest('.hostname-entry')) {
      event.target.closest('.hostname-entry').remove();
    }
  }
}
