import { Controller } from '@hotwired/stimulus';
import { Turbo } from "@hotwired/turbo-rails"

export default class extends Controller {
  static targets = ['existingPictures', 'noPictureMessage'];

  connect() {}

  removePicture(event) {
    event.preventDefault();
    if (event.target.closest('.product-picture')) {
      event.target.closest('.product-picture').remove();
    }

    if (this.existingPicturesTarget.children.length === 0) {
      this.noPictureMessageTarget.classList.remove('hidden');
    }
  }

  addNewPicture(event) {
    event.preventDefault();
    const input = document.createElement('input');
    input.type = 'file';
    input.name = 'asset[file]';
    input.accept = 'image/*';
    input.classList.add('hidden');
    document.body.appendChild(input);
    input.addEventListener('change', this.uploadImage.bind(this));
    input.click();
  }

  uploadImage(event) {
    event.preventDefault();
    const file = event.target.files[0];
    if (!file) return;

    const form = document.createElement('form');
    form.action = '/store/products/add_picture';
    form.method = 'POST';
    form.enctype = 'multipart/form-data';

    form.appendChild(event.target);

    document.body.appendChild(form);
    Turbo.navigator.submitForm(form);
    form.remove();
    this.noPictureMessageTarget.classList.add('hidden');
  }
}
