# frozen_string_literal: true

module Store
  module Api
    module Store
      class VouchersController < ::Store::ApiController
        skip_before_action :verify_authenticity_token, raise: false
        skip_before_action :set_user

        def index
          if params[:token] && (peer = Peer.active.find_by(token: params[:token]))
            @vouchers = Voucher.where(host: peer.host)
            paginate @vouchers, each_serializer: VoucherSerializer
          else
            render_json_error 403, :peer_not_found
          end
        end
      end
    end
  end
end
