# frozen_string_literal: true

module Store
  class ApiController < ::Api::D2::ApplicationController
    def log_action
      status = response.code
      p = params.except(:controller, :action, :uuid, :doc, :space, :auth_token, :file)
      LogJob.add_to_queue(user_id: current_user && current_user.id.to_s, code: "API-STORE-#{controller_path}", action: "status : #{status} | params : #{p}")
    end
  end
end
