# frozen_string_literal: true

App.class_eval do
  field :unpublished_product_nb, type: Integer, default: 0
  field :published_product_nb, type: Integer, default: 0

  validates_presence_of :package

  def to_product(price = 0, duration: '1.year')
    dc, du = duration.split('.')
    Store::Product.new(price:, duration_count: dc, duration_unit: du, package:, title: name, description:, type: 'app')
  end

  def update_product_nb
    self.unpublished_product_nb = Store::Product.unpublished.where(package:).count
    self.published_product_nb = Store::Product.published.where(package:).count
  end

  def self.possible_theme_color
    %w[text-blue-400 text-orange-400 text-red-400 text-green-400 text-purple-400 text-pink-400]
  end

  def self.possible_icon
    ['fas fa-address-book', 'fas fa-cloud', 'fas fa-envelope', 'fas fa-globe', 'fas fa-heart']
  end
end
