# frozen_string_literal: true

module Store
  class ReviewPolicy
    attr_reader :user, :review

    def initialize(user, review)
      @user = user
      @review = review
    end

    def create_review?
      user&.customer?
    end

    def destroy_review?
      user&.admin? || review.user == user
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        scope.all
      end
    end
  end
end
