# frozen_string_literal: true

module Store
  class VoucherPolicy
    attr_reader :user, :voucher

    def initialize(user, voucher)
      @user = user
      @voucher = voucher
    end

    def index?
      user&.customer? || user&.admin?
    end

    def more?
      index?
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        if user&.admin?
          scope.all
        else
          scope.where(user:)
        end
      end
    end
  end
end
