# frozen_string_literal: true

module Store
  class PublicAppSerializer < ActiveModel::Serializer
    attributes :id, :name, :slug, :description, :tags, :version, :type, :get_url, :store, :package, :author, :released_at, :code
    type 'apps'

    def store
      APP_CONFIG['app_host']
    end

    def code
      @instance_options[:code]
    end

    def author
      return unless object.responsible && (dev = User.find_by(id: object.responsible))

      {
        id: dev.id,
        fullname: dev.full_name
      }
    end

    def released_at
      object.created_at
    end
  end
end
