Feature: Users
  Scenario: Redirected when not connected
    Given I am guest
    When I visit the url /store/admin/products
    Then The url is /store/users/sign_in
    And There is a sign in error

  Scenario: Redirected when not admin
    Given I am a logged in developer
    When I visit the url /store/admin/products
    Then The url is /store/admin/products
    And I see and access denied error

  Scenario: I see the products
    Given I am a logged in admin
    And There is some products
    When I visit the url /store/admin/products
    Then The url is /store/admin/products
    And I see the products

  Scenario: I see more products
    Given I am a logged in admin
    And There is all lot of products
    When I visit the url /store/admin/products
    And I scroll down
    Then I see all products

  Scenario: I can sort the products
    Given I am a logged in admin
    And There is some products
    When I visit the url /store/admin/products
    And I click on the sort by title
    Then The products are sorted

  Scenario: I can search
    Given I am a logged in admin
    And There is some products
    When I visit the url /store/admin/products
    When I search for "3"
    Then I only see one product

  Scenario: I can edit a app
    Given I am a logged in admin
    And There is some products
    When I visit the url /store/admin/products
    And I click on the action to edit
    Then The url should match "/store/admin/products/*/admin_edit"
    When I remove the title
    Then I should see form errors
    When I fill the title
    Then The url is /store/admin/products
    And I should see a notification "Product updated successfully"

  Scenario: I can publish/unpublish and product
    Given I am a logged in admin
    And There is some products
    When I visit the url /store/admin/products
    And I click on the publish button
    Then I should see a notification "Product published successfully"
    And I click on the unpublish button
    Then I should see a notification "Product unpublished successfully"

  Scenario: I can promote/unpromote and product
    Given I am a logged in admin
    And There is some products
    When I visit the url /store/admin/products
    And I click on the promote button
    Then I should see a notification "Product promoted successfully"
    And I click on the unpromote button
    Then I should see a notification "Product unpromoted successfully"
