import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some products', () => {
  cy.appFactories([['create_list', 'product_with_app', 5]]);
});

Given('There is all lot of products', () => {
  cy.appFactories([['create_list', 'product_with_app', 30]]);
});

When('I click on the sort by title', () => {
  cy.get('#model_table thead th').contains('Title').click();
});

When('I search for {string}', (title) => {
  cy.get('#model_table input[name="search"]').type(title + '{enter}'); ;
});

When('I click on the action to edit', () => {
  cy.get('#model_table tbody tr').first().find('a[href*="edit"]').click();
});

When('I remove the title' , () => {
  cy.get('input[name="product[title]"]').clear();
  cy.get('input[type="submit"]').click();  
});

When('I fill the title' , () => {
  cy.get('input[name="product[title]"]').type('Test');
  cy.get('input[type="submit"]').click();  
});

When('I click on the publish button', () => {
  cy.get('#model_table tbody tr').first().find('a[href*="/publish"]').click();
});

When('I click on the unpublish button', () => {
  cy.get('#model_table tbody tr').first().find('a[href*="/unpublish"]').click();
});

When('I click on the promote button', () => {
  cy.get('#model_table tbody tr').first().find('a[href*="/promote"]').click();
});

When('I click on the unpromote button', () => {
  cy.get('#model_table tbody tr').first().find('a[href*="/unpromote"]').click();
});



Then('I see the products', () => {
  cy.get('#model_table tbody tr').should('have.length', 5);
});

Then('I see all products', () => {
  cy.get('#model_table tbody tr').should('have.length', 30);
});

Then('The products are sorted', () => {
  cy.get('#model_table tbody td').first().contains('5');
});

Then('I only see one product', () => {
  cy.get('#model_table tbody tr').should('have.length', 1);
});