Feature: Users
  Scenario: Redirected when not connected
    Given I am guest
    When I visit the url /store/admin/users
    Then The url is /store/users/sign_in
    And There is a sign in error

  Scenario: Redirected when not admin
    Given I am a logged in developer
    When I visit the url /store/admin/users
    Then The url is /store/admin/users
    And I see and access denied error

  Scenario: I see the users
    Given I am a logged in admin
    And There is some users
    When I visit the url /store/admin/users
    Then The url is /store/admin/users
    And I see the users

  Scenario: I see more users
    Given I am a logged in admin
    And There is all lot of users
    When I visit the url /store/admin/users
    And I scroll down
    Then I see all users

  Scenario: I can sort the users
    Given I am a logged in admin
    And There is some users
    When I visit the url /store/admin/users
    And I click on the sort by email
    Then The users are sorted

  Scenario: I can edit a app
    Given I am a logged in admin
    And There is some users
    When I visit the url /store/admin/users
    And I click on the action to edit
    Then The url should match "/store/admin/users/*/edit"
    When I remove the first_name
    Then I should see form errors
    When I fill the first_name
    Then The url is /store/admin/users
    And I should see a notification "User updated successfully"

  Scenario: I can block/unblock and user
    Given I am a logged in admin
    And There is some users
    When I visit the url /store/admin/users
    And I click on the block button
    Then I should see a notification "User blocked successfully"
    And I click on the unblock button
    Then I should see a notification "User unblocked successfully"
