import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some users', () => {
  cy.appFactories([['create_list', 'user', 5]]);
});

Given('There is all lot of users', () => {
  cy.appFactories([['create_list', 'user', 30]]);
});

When('I click on the sort by email', () => {
  cy.get('#model_table thead th').contains('Email').click();
});

When('I click on the action to edit', () => {
  cy.get('#model_table tbody tr').eq(1).find('a[href*="edit"]').click();
});

When('I remove the first_name' , () => {
  cy.get('input[name="user[first_name]"]').clear();
  cy.get('input[type="submit"]').click();  
});

When('I fill the first_name' , () => {
  cy.get('input[name="user[first_name]"]').type('John');
  cy.get('input[type="submit"]').click();  
});

When('I click on the block button', () => {
  cy.get('#model_table tbody tr').last().find('a[href*="/block"]').click();
});

When('I click on the unblock button', () => {
  cy.get('#model_table tbody tr').last().find('a[href*="/unblock"]').click();
});

Then('I see the users', () => {
  cy.get('#model_table tbody tr').should('have.length', 6);
});

Then('I see all users', () => {
  cy.get('#model_table tbody tr').should('have.length', 31);
});

Then('The users are sorted', () => {
  cy.get('#model_table tbody td').first().should('not.have.text', 'admin');
});
