Feature: Your apps

  Scenario: Redirect to sign in page if not logged in
    Given I am guest
    When I visit the url /store/apps
    Then The url is /store/users/sign_in
    And There is a sign in error

  Scenario: Redirect if user don't have role
    Given I am not developer
    When I visit the url /store/apps
    Then The url is /store

  Scenario: No redirect if user have role
    Given I am a logged in developer
    When I visit the url /store/apps
    Then The url is /store/apps

  Scenario: I see my apps
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    Then I see my apps

  Scenario: I see more apps
    Given I am a logged in developer
    And There is all lot of my apps
    When I visit the url /store/apps
    And I scroll down
    Then I see all my apps

  Scenario: I can sort the apps
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    And I click on the sort by
    Then The apps are sorted

  Scenario: I can edit a app
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    And I click on the action to edit
    Then The url should match "/store/apps/*/edit"
    When I remove the app name
    Then I should see the error on the app name
    When I fill the app name
    Then The url is /store/apps
    And I should see a notification "App updated successfully"

  Scenario: I can create a new product
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    And I click on the action to create a new product
    And I remove the product title
    Then I should see the error on the product title
    When I fill the product title
    Then The url is /store/apps
    And I should see a notification "Product created successfully"
    And The unpublished counter is increased
    When I visit the url /store/products/unpublished
    Then I see the product

  Scenario: I can create an app
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    And I click on the action to create a new app
    And I try to save an empty app
    Then I should see errors
    When I fill the app form
    Then The url is /store/apps
    And I see the new app
    And I should see a notification "App created successfully"

  Scenario: I can return from creating an app
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/products/unpublished
    And I click on the action to create a new app
    And I click on the action to return
    Then The url is /store/products/unpublished

  Scenario: I can return from editing an app
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    And I click on the action to edit
    And I click on the action to return
    Then The url is /store/apps

  Scenario: I can return from adding a product
    Given I am a logged in developer
    And There is some of my apps
    When I visit the url /store/apps
    And I click on the action to create a new product
    And I click on the action to return
    Then The url is /store/apps