import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some of my apps', () => {
  cy.appFactories([['create_list', 'store_app', 3, { responsible: '1' }]]);
  cy.appFactories([['create', 'store_app', { responsible: 'other_user_id' }]]);
});

Given('There is all lot of my apps', () => {
  cy.appFactories([['create_list', 'store_app', 30, { responsible: '1' }]]);
});

When('I click on the sort by', () => {
  cy.get('#model_table thead th a').first().click();
});

When('I click on the action to edit', () => {
  cy.get('#model_table tbody tr').first().find(`a[href*="edit"]`).first().should('be.visible').click();
});

When('I remove the app name', () => {
  cy.get('input[name="app[name]"]').clear();
  cy.get('input[type="submit"]').click();
});

When('I remove the product title', () => {
  cy.get('input[name="product[title]"]').clear();
  cy.get('input[type="submit"]').click();
});

When('I fill the app name', () => {
  cy.get('input[name="app[name]"]').type('Changed name');
  cy.get('input[type="submit"]').click();
});

When('I fill the product title', () => {
  cy.get('input[name="product[title]"]').type('Changed title');
  cy.get('input[type="submit"]').click();
});

When('I click on the action to create a new product', () => {
  cy.get('#model_table tbody tr').first().find(`a[href*="new_product"]`).first().should('be.visible').click();
});

When('I click on the action to create a new app', () => {
  cy.get('aside').first().find(`a[href*="apps/new"]`).first().should('be.visible').click();
});

When('I try to save an empty app', () => {
  cy.get('input[type="submit"]').click();
});

When('I fill the app form', () => {
  cy.get('input[name="app[name]"]').type('New App');
  cy.get('input[name="app[package]"]').type('new.package.com');
  cy.get('input[type="submit"]').click();
});

Then('I see my apps', () => {
  cy.get('#model_table tbody tr').should('have.length', 3);
});

Then('I see all my apps', () => {
  cy.get('#model_table tbody tr').should('have.length', 30);
});

Then('The apps are sorted', () => {
  cy.get('#model_table tbody tr td').first().contains('3');
});

Then('I should see the error on the app name', () => {
  cy.get('.field_with_errors').should('be.visible');
});

Then('I should see the error on the product title', () => {
  cy.get('.field_with_errors').should('be.visible');
});

Then('I should see errors', () => {
  cy.get('.field_with_errors input').should('be.visible').should('have.length', 2);
});

Then('The unpublished counter is increased', () => {
  cy.get('#model_table tbody tr td').eq(3).contains('1');
});

Then('I see the product', () => {
  cy.get('#model_table tbody tr').should('have.length', 1);
  cy.get('#model_table tbody tr td').first().contains('Changed title');
});

Then('I see the new app', () => {
  cy.get('#model_table tbody tr').should('have.length', 4);
  cy.get('#model_table tbody tr td').contains('New App');
});
