Feature: Signin

  Scenario: Sign in working
    Given There is an user
    When I visit the store
    And I click on sign in button
    Then The url is /store/users/sign_in
    When I use the proper login
    Then The url is /store/admin/users
    And I am logged in

  Scenario: Wrong login
    Given There is an user
    When I visit the store
    And I click on sign in button
    Then The url is /store/users/sign_in
    When I use the wrong login
    Then The url is /store/users/sign_in
    And There is a sign in error

  Scenario: Forgot password working
    Given There is an user
    When I visit the store sign in page
    And I click on forgot password link
    Then The url is /store/users/password/new
    When I use the proper email
    Then The url is /store

  Scenario: Forgot password wrong email
    Given There is an user
    When I visit the store sign in page
    And I click on forgot password link
    Then The url is /store/users/password/new
    When I use the wrong email
    Then The url is /store/users/password
    And I see error message

  Scenario: Edit password working
    Given There is an user with a reset_password_token
    When I visit the store password reset page
    And I add a new password
    Then The url is /store

  Scenario: Edit password wrong token
    Given There is an user with a reset_password_token
    When I visit the store password reset page with a wrong token
    And I add a new password
    Then The url is /store/users/password
    And I see error message

  Scenario: Edit password wrong password
    Given There is an user with a reset_password_token
    When I visit the store password reset page
    And I add a new password with wrong confirmation
    Then The url is /store/users/password
    And I see error message

  Scenario: Edit password too simple password
    Given There is an user with a reset_password_token
    When I visit the store password reset page
    And I add a new password with too simple password
    Then The url is /store/users/password
    And I see error message

  Scenario: I sign out
    Given There is an user
    When I visit the store
    And I click on sign in button
    Then The url is /store/users/sign_in
    When I use the proper login
    Then The url is /store/admin/users
    When I sign out
    Then The url is /store
    And I am not logged in

  Scenario: Change language
    Given There is an user
    When I visit the url /store/users/sign_in
    Then I see the page in english
    When I change the language to "fr"
    Then I see the page in french
    When I change the language to "en"
    Then I see the page in english