import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('I am on the home page', () => {
  cy.app('clean');
  cy.visit(`${Cypress.config().baseUrl}/store`);
});

When('I click on the signup button', () => {
  cy.get('#sign-up-button').click();
});

Then('I select customer', () => {
  cy.get('label').last().click();
  cy.get('#sign-up-button').click();
});

When('I fill correctly the sign up form', () => {
  cy.get('#user_login').type('johndoe');
  cy.get('#user_first_name').type('John');
  cy.get('#user_last_name').type('Doe');
  cy.get('#user_email').type('johndoe@test.com');
  cy.get('#user_phone_number').type('0101010101');
  cy.get('#user_password').type('Password1!');
  cy.get('#user_password_confirmation').type('Password1!');
  cy.get('#sign-up-button').click();
});

When('I fill incorrectly the sign up form', () => {
  cy.get('#user_login').type('johndoe');
  cy.get('#user_first_name').type('John');
  cy.get('#user_last_name').type('Doe');
  cy.get('#user_email').type('johndoe@test.com');
  cy.get('#user_phone_number').type('0101010101');
  cy.get('#user_password').type('Password1!');
  cy.get('#user_password_confirmation').type('Passw');
  cy.get('#sign-up-button').click();
});

Given('I set the user confirmation token', () => {
  cy.appScenario('set_user_confirmation_token');
});

When('I visit the confirmation page from the email', () => {
  cy.visit(`${Cypress.config().baseUrl}/store/users/confirmation?confirmation_token=123456`);
});

When('I visit the sign up page', () => {
  cy.visit(`${Cypress.config().baseUrl}/store/users/sign_up`);
});

Then('I should see an error message', () => {
  cy.get('.field_with_errors').should('be.visible');
});

Then('I see the page in french', () => {
  cy.get('#language-changer').should('have.value', 'fr');
  cy.get("form input[type='submit']").contains('Étape suivante');
});

Then('I see the page in english', () => {
  cy.get('#language-changer').should('have.value', 'en');
  cy.get("form input[type='submit']").contains('Next step');
});
