Feature: Errors

  Scenario: Not found as guest
    Given I am guest
    When I visit the url /store/dsqdsqdq
    Then The url is /store/dsqdsqdq
    And I see the not found page
    When I click on go back button
    Then The url is /store

  Scenario: Not found as customer
    Given I am a logged in customer
    When I visit the url /store/dsqdsqdq
    Then The url is /store/dsqdsqdq
    And I see the not found page
    When I click on go back button
    Then The url is /store/vouchers

  Scenario: Not found stream
    Given I am a logged in customer
    When I visit the url /store/generate_error
    When I generate a 404 error on a turbo stream request
    Then I should see a notification "The page you were looking for doesn't exist"

  Scenario: 500 as customer
    Given I am a logged in customer
    When I visit the url /store/generate_error?code=500
    Then The url is /store/generate_error?code=500
    And I see the 500 error page
    When I click on go back button
    Then The url is /store/vouchers

  Scenario: 500 on a stream as customer
    Given I am a logged in customer
    When I visit the url /store/generate_error
    And I generate a 500 error on a turbo stream request
    Then The url is /store/generate_error
    And I should see a notification "Something went wrong"

  Scenario: 403 as customer
    Given I am a logged in customer
    When I visit the url /store/generate_error?code=403
    Then The url is /store/generate_error?code=403
    And I see the 403 error page
    When I click on go back button
    Then The url is /store/vouchers

  Scenario: 403 on a stream as customer
    Given I am a logged in customer
    When I visit the url /store/generate_error
    And I generate a 403 error on a turbo stream request
    Then The url is /store/generate_error
    And I should see a notification "Access denied"