import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('I am admin logged in', () => {
  cy.app('clean');
  cy.appScenario('with_admin');
  cy.addAuthHeader('admin_token');
});

Given('There is some products', () => {
  cy.appFactories([['create_list', 'product_with_app', 26, 'published']]);
  cy.appFactories([['create_list', 'product_with_app', 4, 'published', { promoted: true }]]);
});

When('I login', () => {
  cy.storeLogin('admin@cypress.fr', 'Password1!');
});

When('I visit the store', () => {
  cy.visit(`${Cypress.config().baseUrl}/store`);
});

When('I search for an product', () => {
  cy.get('input#search-products').type('1{enter}');
});

Then('the url is {word}', url => {
  cy.url().should('eq', `${Cypress.config().baseUrl}${url}`);
});

Then('I see some products', () => {
  cy.get('.product-card ').should('exist');
});

Then('I see all the products', () => {
  cy.get('.product-card').should('have.length', 30);
});

Then('I see the price', () => {
  cy.get('.product-card').first().find('.price').should('exist');
});

Then('I see the more button', () => {
  cy.get('.product-card').first().find('.detail-btn').contains('More info');
});

Then('I see the buy button', () => {
  cy.get('.product-card').first().find('.buy-btn').contains('Buy');
});

Then("I don't see the price but the more button", () => {
  cy.get('.product-card').first().find('.price').should('not.exist');
  cy.get('.product-card').first().find('.detail-btn').contains('More info');
});

Then('I see the result is {int}', result => {
  cy.get('#result-number').should('contain', result);
});

Then('I see the {int} products', number => {
  cy.get('.product-card').should('have.length', number);
});

Then('I see the page in french', () => {
  cy.get('#language-changer').should('have.value', 'fr');
  cy.get('#sign-in-button').contains('Connexion');
});

Then('I see the page in english', () => {
  cy.get('#language-changer').should('have.value', 'en');
  cy.get('#sign-in-button').contains('Sign in');
});
