Feature: Cart

  Scenario: Buy
    Given I am a logged in customer
    And There is some products
    When I visit the url /store
    And I click on the buy button
    Then The url is /store/orders/cart
    And The cart link is number is 1
    And I should see the product in the cart

  Scenario: Add to cart
    Given I am a logged in customer
    And There is some products
    When I visit the url /store
    And I click on the add to cart button
    Then The url is /store
    And The cart link is number is 1
    And I should see a notification "The product added to your cart"

  Scenario: Can remove from cart
    Given I am a logged in customer
    And I have a product in the cart
    When I visit the url /store/orders/cart
    Then I should see the product in the cart
    When I click on the remove button
    Then The url is /store/orders/cart
    And I should not see any products in the cart
    And The cart link is number is 0

  Scenario: Can go back to store
    Given I am a logged in customer
    And I have a product in the cart
    When I visit the url /store/orders/cart
    Then I should see the product in the cart
    When I click on the back button
    Then The url is /store

  Scenario: Can checkout
    Given I am a logged in customer
    And I have a product in the cart
    When I visit the url /store/orders/cart
    And I click on the checkout button
    Then The url is /store/vouchers

  Scenario: Can select host
    Given I am a logged in customer
    And I have 2 product in the cart
    When I visit the url /store/orders/cart
    And I change the host of the first product to "www.google.com"
    Then The select host value of the first product is "www.google.com"

  Scenario: I can add new host
    Given I am a logged in customer
    And I have 2 product in the cart
    When I visit the url /store/orders/cart
    And I add a new host "test.com"
    Then The select host value of the first product is "test.com"
    And The select host of the second product contains "test.com"

  Scenario: I get an error if I add an invalid host
    Given I am a logged in customer
    And I have 2 product in the cart
    When I visit the url /store/orders/cart
    And I add a new host "test"
    And I should see a notification "test is not a valid hostname"
