import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some products', () => {
  cy.appFactories([['create_list', 'product_with_app', 5, 'published']]);
});

Given('I have a product in the cart', () => {
  cy.appFactories([['create', 'product_with_app', { id: '1' }]]);
  cy.appFactories([['create', 'voucher', { id: '1', user_id: '1', active: false, product_id: '1' }]]);
  cy.appFactories([['create', 'order', { user_id: '1', is_cart: true, voucher_ids: ['1'] }]]);
});

Given('I have 2 product in the cart', () => {
  cy.appFactories([['create', 'product_with_app', { id: '1' }]]);
  cy.appFactories([['create', 'voucher', { id: '1', user_id: '1', active: false, product_id: '1' }]]);
  cy.appFactories([['create', 'product_with_app', { id: '2' }]]);
  cy.appFactories([['create', 'voucher', { id: '2', user_id: '1', active: false, product_id: '2' }]]);
  cy.appFactories([['create', 'order', { user_id: '1', is_cart: true, voucher_ids: ['1', '2'] }]]);
});

When('I click on the remove button', () => {
  cy.get('.cart-item').first().find('.btn-remove-from-cart').first().click();
});

When('I click on the back button', () => {
  cy.get('#go-back-to-shopping').first().click();
});

When('I click on the checkout button', () => {
  cy.get('input[type="submit"]').first().click();
});

When('I click on the buy button', () => {
  cy.get('.buy-btn').first().click();
});

When('I click on the add to cart button', () => {
  cy.get('.add-to-cart-btn').first().click();
});

When('I change the host of the first product to {string}', host => {
  cy.get('select[data-controller="cart-host').first().next('div').click();
  cy.get('.ss-option').should('exist').eq(1).should('be.visible').click();
});

When('I add a new host {string}', host => {
  cy.get('select[data-controller="cart-host').first().next('div').click();
  cy.get('.ss-search input').first().type(host);
  cy.get('.ss-addable').first().click();
});

Then('I should see the product in the cart', () => {
  cy.get('#item-container li').should('have.length', 1);
});

Then('I should not see any products in the cart', () => {
  cy.get('#item-container li').should('have.length', 0);
});

Then('The cart link is number is {int}', result => {
  cy.get('#cart-link div').should('contain', result);
});

Then('The select host value of the first product is {string}', host => {
  cy.get('select[data-controller="cart-host"]').first().should('have.value', host);
});

Then('The select host of the second product contains {string}', host => {
  cy.get('select[data-controller="cart-host').eq(1).next('div').click();
  cy.get('.ss-option').should('exist').eq(2).contains(host);
});
