import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some orders', () => {
  cy.appFactories([['create_list', 'order', 2, { user_id: '1' }]]);
  cy.appFactories([['create', 'order', { user_id: '1', created_at: '2040-01-01' }]]);

  cy.appFactories([['create', 'order', { user_id: 'other_user_id' }]]);
  cy.appFactories([['create', 'order', { user_id: '1', is_cart: true }]]);
});

Given('There is a lot of orders', () => {
  cy.appFactories([['create_list', 'order', 30, { user_id: '1' }]]);
});

When('I click on the sort by', () => {
  cy.get('#model_table thead th a').first().click();
});

When('I click on the button to see details', () => {
  cy.get('a[href*="show"]').first().click();
});

Then('I see my orders', () => {
  cy.get('#model_table tbody tr').should('have.length', 3);
});

Then('I see all my orders', () => {
  cy.get('#model_table tbody tr').should('have.length', 30);
});

Then('The orders are sorted', () => {
  cy.get('#model_table tbody tr td').first().contains('2040-01-01 00:00:00 +0100');
});
