import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is one product with reviews', () => {
  cy.appFactories([['create', 'product_with_app', 'with_reviews', 'published', { id: '1', reviews_count: 20 }]]);
});

Given('I have a review', () => {
  cy.appFactories([['create', 'store_review', { user_id: '1', product_id: '1', rating: 3, comment: 'This is a average product!' }]]);
});

When('I visit the product detail page', () => {
  cy.visit(`${Cypress.config().baseUrl}/store/products/1/product_details`);
});

When('I fill the review form', () => {
  cy.get('textarea[name="review[comment]"]').type('This is a great product!');
  cy.get('input[type="submit"]').click();
});

When('I click on the delete review button', () => {
  cy.get('.review').first().find('a').first().click();
});

Then('I see all the reviews', () => {
  cy.get('.review').should('have.length', 20);
});

Then('I see my review', () => {
  cy.get('.review').first().should('contain', 'This is a great product!');
});

Then("I don't see my review", () => {
  cy.get('.review').first().should('not.contain', 'This is a average product!');
});

Then("I don't see the review form", () => {
  cy.get('textarea[name="review[comment]"]').should('not.exist');
});
