Feature: Published

Scenario: Redirect to sign in page if not logged in
  Given I am guest
  When I visit the url /store/products/published
  Then The url is /store/users/sign_in
  And There is a sign in error

Scenario: Redirect if user don't have role
  Given I am not developer
  When I visit the url /store/products/published
  Then The url is /store

Scenario: No redirect if user have role
  Given I am a logged in developer
  When I visit the url /store/products/published
  Then The url is /store/products/published

Scenario: After sign redirect to developer dashboard
  Given I am already sign up as a developer
  When I sign in as a developer
  Then The url is /store/products/published

Scenario: I see my published products
  Given I am a logged in developer
  And There is some products published by me
  When I visit the url /store/products/published
  Then I see my published products

Scenario: I see more products
  Given I am a logged in developer
  And There is a lot of products published by me
  When I visit the url /store/products/published
  And I scroll down
  Then I see all my published products

Scenario: I can sort the products
  Given I am a logged in developer
  And There is some products published by me
  When I visit the url /store/products/published
  And I click on the sort by
  Then The products are sorted

Scenario: I can go the product details page
  Given I am a logged in developer
  And There is some products published by me
  When I visit the url /store/products/published
  And I click on a product
  Then The url should match "/store/products/*/product_details"
  When I visit the url /store/products/published
  Then The url is /store/products/published
  When I click on the action show details
  Then The url should match "/store/products/*/product_details"

Scenario: I can unpublish a product
  Given I am a logged in developer
  And There is some products published by me
  When I visit the url /store/products/published
  And I click on the action to unpublish
  Then The product is unpublished
  And I should see a notification "The product unpublished"

