import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some products published by me', () => {
  cy.appFactories([['create_list', 'product_with_app', 3, 'published', { user_id: '1' }]]);
  cy.appFactories([['create', 'product_with_app', 'published', { user_id: 'other_user_id' }]]);
  cy.appFactories([['create', 'product_with_app', { user_id: '1' }]]);
});

Given('There is a lot of products published by me', () => {
  cy.appFactories([['create_list', 'product_with_app', 30, 'published', { user_id: '1' }]]);
});

When('I sign in as a developer', () => {
  cy.storeLogin('johndoe@test.com', 'Password1!');
});

When('I click on a product', () => {
  cy.get('#model_table tbody a').first().click();
});

When('I click on the action show details', () => {
  cy.get('#model_table tbody tr').first().find(`a[href*="details"]`).first().should('be.visible').click();
});

When('I click on the action to edit', () => {
  cy.get('#model_table tbody tr').first().find(`a[href*="edit"]`).first().should('be.visible').click();
});

When('I remove the product title', () => {
  cy.get('input[name="product[title]"]').clear();
  cy.get('input[type="submit"]').click();
});

When('I fill the product title', () => {
  cy.get('input[name="product[title]"]').type('Changed title');
  cy.get('input[type="submit"]').click();
});

When('I click on the action to unpublish', () => {
  cy.get('#model_table tbody tr').first().find(`a[href*="unpublish"]`).first().should('be.visible').click();
});

When('I click on the sort by', () => {
  cy.get('#model_table thead th a').first().click();
});

Then('I see my published products', () => {
  cy.get('#model_table tbody tr').should('have.length', 3);
});

Then('I see all my published products', () => {
  cy.get('#model_table tbody tr').should('have.length', 30);
});

Then('I should see the error on the product title', () => {
  cy.get('.field_with_errors').should('be.visible');
});

Then('The product is unpublished', () => {
  cy.get('#model_table tbody tr').should('have.length', 2);
});

Then('The products are sorted', () => {
  cy.get('#model_table tbody tr td').first().contains('3');
});

Then('I see the error 403 page', () => {
  cy.get('body').should('contain', 'Access denied');
});