Feature: Unpublished

  Scenario: Redirect to sign in page if not logged in
    Given I am guest
    When I visit the url /store/products/unpublished
    Then The url is /store/users/sign_in
    And There is a sign in error

  Scenario: Redirect if user don't have role
    Given I am not developer
    When I visit the url /store/products/unpublished
    Then The url is /store

  Scenario: No redirect if user have role
    Given I am a logged in developer
    When I visit the url /store/products/unpublished
    Then The url is /store/products/unpublished

  Scenario: I see my unpublished products
    Given I am a logged in developer
    And There is some products unpublished
    When I visit the url /store/products/unpublished
    Then I see my unpublished products

  Scenario: I see more products
    Given I am a logged in developer
    And There is a lot of products unpublish
    When I visit the url /store/products/unpublished
    And I scroll down
    Then I see all my unpublished products

  Scenario: I can sort the products
    Given I am a logged in developer
    And There is some products unpublished
    When I visit the url /store/products/unpublished
    And I click on the sort by
    Then The products are sorted

  Scenario: I can go the product details page
    Given I am a logged in developer
    And There is some products unpublished
    When I visit the url /store/products/unpublished
    And I click on a product
    Then The url should match "/store/products/*/product_details"

    When I visit the url /store/products/unpublished
    Then The url is /store/products/unpublished

    When I click on the action show details
    Then The url should match "/store/products/*/product_details"

  Scenario: I can edit a product
    Given I am a logged in developer
    And There is some products unpublished
    When I visit the url /store/products/unpublished
    And I click on the action to edit
    Then The url should match "/store/products/*/edit"
    When I remove the product duration
    Then I should see the error on the product duration
    When I fill the product duration
    Then The url is /store/products/unpublished
    And I should see a notification "Product updated successfully"

  Scenario: I can return from editing an product
    Given I am a logged in developer
    And There is some products unpublished
    When I visit the url /store/products/unpublished
    And I click on the action to edit
    And I click on the action to return
    Then The url is /store/products/unpublished

  Scenario: I can ask to publish a product
    Given I am a logged in developer
    And There is some products unpublished
    When I visit the url /store/products/unpublished
    And I click on the action to ask to publish
    Then The product is unpublished
    And I should see a notification "Product submited for review"

  Scenario: I can add pictures to a product
    Given I am a logged in developer
    And There is one products unpublish
    When I visit the url /store/products/1/edit
    When I add a picture
    Then The url is /store/products/unpublished
    And I should see a notification "Product updated successfully"
    When I visit the url /store/products/1/product_details
    Then I see the new picture

  Scenario: I can remove pictures to a product
    Given I am a logged in developer
    And There is one products unpublish
    When I visit the url /store/products/1/edit
    When I remove a picture
    Then The url is /store/products/unpublished
    And I should see a notification "Product updated successfully"
    When I visit the url /store/products/1/product_details
    Then I not see the picture

  Scenario: I can reorder the pictures
    Given I am a logged in developer
    And There is one products unpublish
    When I visit the url /store/products/1/edit
    When I reorder the pictures
    Then The url is /store/products/unpublished
    And I should see a notification "Product updated successfully"
    When I visit the url /store/products/1/product_details
    Then I see the last picture first
