Feature: Edit my profile

  Scenario: Redirect to sign in page if not logged in
    Given I am guest
    When I visit the url /store/users/edit_profile
    Then The url is /store/users/sign_in
    And There is a sign in error

  Scenario: I can edit my profile
    Given I am a logged in developer
    When I visit the url /store/users/edit_profile
    Then The url is /store/users/edit_profile
    When I change my name
    Then I should see a notification "Profile updated successfully"
    And I should see my new name

  Scenario: I see the errors
    Given I am a logged in developer
    When I visit the url /store/users/edit_profile
    Then The url is /store/users/edit_profile
    When I clear my name
    Then I should see form errors

  Scenario: I can change my position
    Given I am a logged in developer
    When I visit the url /store/users/edit_profile
    Then The url is /store/users/edit_profile
    When I change my position
    Then I should see a notification "Profile updated successfully"
    And I am now a customer

  Scenario: Change language
    Given I am a logged in developer
    When I visit the url /store/users/edit_profile
    Then I see the page in english
    When I change my language to "fr"
    Then I should see a notification "Votre profil a été mis à jour avec succès"
    Then I see the page in french
    When I change my language to "en"
    Then I see the page in english

  Scenario: I can manage hostname
    Given I am a logged in customer
    When I visit the url /store/users/edit_profile
    And I add hostnames
    Then I should see a notification "Profile updated successfully"
    And I see my hostnames
    When I remove all my hostnames
    Then I should see a notification "Profile updated successfully"
    And I see no hostnames
    When I add a invalid hostname
    Then I should see invalid hostname error
