import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

When('I change my name', () => {
  cy.get('#user_first_name').clear().type('John');
  cy.get('input[type=submit]').click();
});

When('I clear my name', () => {
  cy.get('#user_first_name').clear();
  cy.get('input[type=submit]').click();
});

When('I change my position', () => {
  cy.get('#user_position').select('Customer');
  cy.get('input[type=submit]').click();
});

When('I change my language to {string}', locale => {
  cy.get('#user_locale').select(locale);
  cy.get('input[type=submit]').click();
});

When('I add hostnames', () => {
  cy.get("button[data-action='click->hostnames#addHostname']").click();
  cy.get("input[name='user[hostnames][]']").last().type('example.com');

  cy.get("button[data-action='click->hostnames#addHostname']").click();
  cy.get("input[name='user[hostnames][]']").last().type('GOOGLE.COM');

  cy.get("button[data-action='click->hostnames#addHostname']").click();
  cy.get("input[name='user[hostnames][]']").last().type('GOOGLE.COM');

  cy.get("button[data-action='click->hostnames#addHostname']").click();
  cy.get('input[type=submit]').click();
});

When('I remove all my hostnames', () => {
  cy.get('button[data-action="click->hostnames#removeHostname"]').last().click();
  cy.get('button[data-action="click->hostnames#removeHostname"]').last().click();
  cy.get('button[data-action="click->hostnames#removeHostname"]').last().click();
  cy.get('button[data-action="click->hostnames#removeHostname"]').last().click();

  cy.get('input[type=submit]').click();
});

When('I add a invalid hostname', () => {
  cy.wait(200);
  cy.get("button[data-action='click->hostnames#addHostname']").click();
  cy.get("input[name='user[hostnames][]']").last().type('aaaaaaaa');
  cy.get('input[type=submit]').click();
});

Then('I should see my new name', () => {
  cy.get('#user-name').should('contain', 'John');
});

Then('I am now a customer', () => {
  cy.get('#cart-link').should('be.visible');
});

Then('I see the page in french', () => {
  cy.get('#user_locale').should('have.value', 'fr');
  cy.get('h1').first().contains('Modifier votre profil');
});

Then('I see the page in english', () => {
  cy.get('#user_locale').should('have.value', 'en');
  cy.get('h1').first().contains('Edit your profile');
});

Then('I see my hostnames', () => {
  cy.get('div[data-hostnames-target="container"] div').should('have.length', 4);
  cy.get('div[data-hostnames-target="container"] div').eq(2).find('input').should('have.value', 'example.com');
  cy.get('div[data-hostnames-target="container"] div').last().find('input').should('have.value', 'google.com');
});

Then('I see no hostnames', () => {
  cy.get('div[data-hostnames-target="container"] div').should('have.length', 0);
});


Then('I should see invalid hostname error', () => {
  cy.get('div[data-hostnames-target="container"').contains('Hostnames aaaaaaaa is not a valid hostname');
});