import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is some vouchers', () => {
  cy.appFactories([['create_list', 'voucher', 3, 'with_code', { user_id: '1' }]]);
  cy.appFactories([['create', 'voucher', 'with_code', { user_id: 'other_user_id' }]]);
  cy.appFactories([['create', 'voucher', { user_id: '1' }]]);
});

Given('There is a lot of vouchers', () => {
  cy.appFactories([['create_list', 'voucher', 30, 'with_code', { user_id: '1' }]]);
});

When('I click on the sort by', () => {
  cy.get('#model_table thead th a').first().click();
});

When('I click on the copy code button', () => {
  cy.window().then(win => {
    const clipboardSpy = cy.stub(win.navigator.clipboard, 'writeText').callsFake(text => Promise.resolve());
    cy.wrap(clipboardSpy).as('clipboardSpy');
  });
  cy.get('button[data-action="clipboard#copy"]').first().click();
});

When('I click on the buy button', () => {
  cy.get('a[href*="buy"]').first().click();
});

Then('I see my vouchers', () => {
  cy.get('#model_table tbody tr').should('have.length', 3);
});

Then('I see all my vouchers', () => {
  cy.get('#model_table tbody tr').should('have.length', 30);
});

Then('The vouchers are sorted', () => {
  cy.get('#model_table tbody tr td').first().contains('3');
});

Then('The code is copied', () => {
  cy.get('button[data-action="clipboard#copy"]').first().should('contain', 'Copied!');
});
