# frozen_string_literal: true

require 'faker'

FactoryBot.define do
  factory :store_app, class: App do
    sequence(:name) { |n| " #{n} #{Faker::App.name}" }
    package { name.downcase.gsub(' ', '_') }
    description { Faker::Lorem.paragraphs(number: 2).join("\n\n") }
    icon { App.possible_icon.sample }
    background_color { App.possible_theme_color.sample }
    theme_color { App.possible_theme_color.sample }

    before :create do |app|
      app.package = "#{app.package}#{rand(1..9)}" while App.exists?(package: app.package)
      app.name = "#{app.name}#{rand(1..9)}" while App.exists?(name: app.name)
    end
  end
end
