# frozen_string_literal: true

require 'faker'

FactoryBot.define do
  factory :voucher, class: Store::Voucher do
    product { create(:product_with_app, :published) }
    host { 'localhost' }

    trait :with_code do
      code { Faker::Code.unique.asin }

      after(:create) do |voucher, _evaluator|
        voucher.gen_code
        voucher.save
      end
    end
  end
end
