# frozen_string_literal: true

require 'rails_helper'

describe Store::VoucherPolicy do
  subject { described_class }

  permissions :index?, :more? do
    it 'denies access if not customer' do
      expect(subject).not_to permit(FactoryBot.create(:user), Store::Voucher)
    end

    it 'grants access if customer' do
      expect(subject).to permit(FactoryBot.create(:user, position: 'customer'), Store::Voucher)
    end

    it 'grants access if admin' do
      expect(subject).to permit(FactoryBot.create(:user, roles: ['Administrator']), Store::Voucher)
    end
  end
end
