# frozen_string_literal: true

class ProductCardComponentPreview < ViewComponent::Preview
  layout 'store/component_preview'

  # @param title text
  # @param description text
  # @param color select [text-blue-400, text-orange-400, text-red-400, text-green-400, text-purple-400, text-pink-400]
  # @param icon select [fas fa-address-book, fas fa-cloud, fas fa-envelope, fas fa-globe, fas fa-heart]
  # @param is_guest select [true, false]
  def standard(
    color: 'text-blue-400',
    icon: 'fas fa-address-book',
    title: 'App Name',
    description: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla eu condimentum purus, eget ornare magna.',
    is_guest: false
  )
    file_name = File.basename(Dir.glob('packages/store/app/assets/images/store/product_picture_url_samples/*').first)
    product = OpenStruct.new(
      title:,
      description:,
      app: OpenStruct.new(icon:, theme_color: color),
      price: 100,
      free: false,
      rating_count: 10,
      rating: 4.5,
      duration_unit: 'year',
      duration_count: 1,
      main_picture_url: "/assets/store/product_picture_url_samples/#{file_name}"
    )
    user = nil
    user = OpenStruct.new unless is_guest
    render Store::ProductCardComponent.new(product:, user:)
  end
end
